#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>

#include <InputServerFilter.h>
#include <InterfaceDefs.h>
#include <Message.h>

class _EXPORT FWork;

class FWork : public BInputServerFilter
{
	public:
		FWork(void);
		filter_result Filter(BMessage *message, BList *outList);
};

FWork::FWork(void)
	: BInputServerFilter()
{
	//BAlert *alert = new BAlert(NULL, "Hello", "Ok");
	//alert->Go(NULL);
}

filter_result FWork::Filter(BMessage *message, BList *outList)
{
	if(message->what == B_KEY_DOWN)
	{
		int32 key;
		message->FindInt32("key", &key);
		if(key >= B_F1_KEY && key <= B_F12_KEY)
		{
			int32 modifiers;
			message->FindInt32("modifiers", &modifiers);
			//if cmd is pressed, map it to normal F keys
			//if cmd is not pressed, map to cmd-f keys
			if(modifiers & B_COMMAND_KEY)
				modifiers ^= B_COMMAND_KEY;
			else
				modifiers |= B_COMMAND_KEY;
			message->ReplaceInt32("modifiers", modifiers);
		}
	}
	return B_DISPATCH_MESSAGE;
}

extern "C"  { _EXPORT extern BInputServerFilter *instantiate_input_filter(void); }

BInputServerFilter *instantiate_input_filter(void)
{
	return new FWork();
}